<?php
// JF 2009  - 2017
// Affiche les positions istantanées des bateaux de SailOnLine en exportant un fichier KML
// Pas de base de données ni de stokage des trajectoires.


define ('DEBUG', 0);      // debogage maison !:))
//define ('DEBUG', 1);

require_once('include/zip.php'); // utilise la bibliotheque pclzip
require_once('include/cache_voiliers.php'); // fonction de cache pour les donnees voilier
require_once('include/Voilier.php'); // Définition de la classe Voilier
require_once('include/kml_trajectoire.php'); // Génération KML de la trajectoire
require_once('include/kml_3d.php'); // Génération KML des bateaux comme des modeles 3D

$scale=2;		// valeur d'echelle des voiliers 3D par defaut
$mode='3D'; // affichage 3D des bateau par défaut
$ok3d=true;
$dossier_3d='sol3d';
$dossier_3d_cache=$dossier_3d; // initialise avec la date par un appel de fonction
$extension_dae='.dae'; // fichier COLLADA
$extension_kmz='.kmz'; // lue par Google Earth
$extension_kml='.kml'; // lue par Google Earth
$dossier_textures='textures';
$dossier_modeles='models';
$okmarques=false;  // pas de marques de parcours
$t_url_fichier_marque=array(); // '/marques/MarquesParcoursVGV2016.kml','/marques/MarquesParcoursVGV2016.kml');
$t_url_serveur=array();
$utiliser_cache=0; // par defaut il y a pas de cache d'une heure sur les donnes des voiliers
$datacache='data'; // dossier de cache des voiliers; doit exister sur le serveur
$ext_data='.dat';	// fichier de donnees sauvegardee
$MAXTAILLECACHE='1024';
$appli='';
$n=0;

// Variable pour le téléchargement des fichiers de données
$path='race_info';
$prefix='race_';
$extension='.xml';

$coursenumber='1018';
$token='dd1d3af4ab5710c1eceadf16f4909ffb';

$action='';
$nomfichier='';
$filename='';
$voile=1; // Foc par défaut
$t_voilier = array(); // liste des voiliers chargés

if (!empty($_SERVER['HTTPS']) && ('on' == $_SERVER['HTTPS'])) {
	$uri = 'https://';
} else {
	$uri = 'http://';
}


//$url_serveur_local = $uri.$_SERVER['HTTP_HOST'].':'.$_SERVER['SERVER_PORT'].get_url_pere($_SERVER['SCRIPT_NAME']);
$url_serveur_local = $uri.$_SERVER['HTTP_HOST'].get_url_pere($_SERVER['SCRIPT_NAME']);

// DEBUG
// echo "<br>URL : $url_serveur_local\n";

$dir_serveur = dirname($_SERVER['SCRIPT_FILENAME']);
// DEBUG
// echo "<br>Répertoire serveur : $dir_serveur\n";
// Nom du script chargé dynamiquement.
$appli=$_SERVER["PHP_SELF"];

// heure    minute seconde jour mois annee
//$to_ten_minutes  = mktime(date("G"), date("i")+10, 0, date("m"),date("d"),date("Y"));
$to_one_hour  = mktime(date("G")+1, 0, 0, date("m"),date("d"),date("Y"));
//$from_ten_minutes  = mktime(date("G"), date("i")+10, 0, date("m")  , date("d"), date("Y"));
$from_one_hour  = mktime(date("G"), 0, 0, date("m")  , date("d"), date("Y"));
$date_cache_one_hour=date("Y-m-d H:i:s",$from_one_hour);
//$date_cache_ten_minutes=date("Y-m-d H:i:s",$from_ten_minutes);
//$str_time_cache_ten_minutes = " de dix minutes ";
$str_time_cache_one_hour = " d'une heure ";

// Dix minutes non completement implanté. A TERMINER... dans ExisteKML
//$date_cache=$date_cache_ten_minutes;
//$to_next_time_cache = $to_ten_minutes; // Cela pourrait être laissé à l'utilisateur
//$time_cache = $from_ten_minutes;
//$str_time_cache = $str_time_cache_ten_minutes;
// Seul le cache de 60 minutes est implanté car plus simple
$date_cache=$date_cache_one_hour;
$to_next_time_cache = $to_one_hour; // Cela pourrait être laissé à l'utilisateur
$time_cache = $from_one_hour;
$str_time_cache = $str_time_cache_one_hour;

$url_serveur=$url_serveur_local; // par defaut le serveur sur lequel s'exécute le script
$url_serveur_marques_parcours=$url_serveur;

// COOKIES INPUT
if (isset($_COOKIE["solcoursenumber"]) && !empty($_COOKIE["solcoursenumber"])){
	$coursenumber=$_COOKIE["solcoursenumber"];
}
if (isset($_COOKIE["soltoken"]) && !empty($_COOKIE["soltoken"])){
	$token=$_COOKIE["soltoken"];
}

// GET
if (isset($_GET['filename'])){
	$filename=$_GET['filename'];
	$action="go";
}
if (isset($_GET['coursenumber'])){
	$coursenumber=$_GET['$coursenumber'];
}
if (isset($_GET['coursename'])){
	$coursename=$_GET['$coursename'];
}

if (isset($_GET['token'])){
	$token=$_GET['$token'];
}

// POST
if (isset($_POST['coursenumber'])){
	$coursenumber=$_POST['coursenumber'];
}
if (isset($_POST['coursename'])){
	$coursename=$_POST['coursename'];
}

if (isset($_POST['token'])){
	$token=$_POST['token'];
}

if (isset($_POST['action'])){
	$action=$_POST['action'];
}

	if (isset($_POST['newserveur']) && ($_POST['newserveur']!='')){
		$url_serveur=$_POST['newserveur'];
		$url_serveur_marques_parcours=$url_serveur;
	}

	if (isset($_POST['url_serveur']) && ($_POST['url_serveur']!='')){
		$url_serveur=$_POST['url_serveur'];
		$url_serveur_marques_parcours=$url_serveur;
	}
	// cache temporel sur les donnes des voiliers
	if (isset($_POST['utiliser_cache']) && ($_POST['utiliser_cache']!='')){
		$utiliser_cache=$_POST['utiliser_cache'];
	}

	// 2D ou 3D
	if (isset($_POST['mode']) && ($_POST['mode']!='')){
		$mode=$_POST['mode'];
	}

	// echelle des bateaux
	if (isset($_POST['scale']) && ($_POST['scale']!='')){
		$scale=$_POST['scale'];
	}
	// voile des bateaux
	if (isset($_POST['voile']) && ($_POST['voile']!='')){
		$voile=$_POST['voile'];
	}

// COOKIES  OUTPUT
if (isset($token) && ($token!="") ){
	setcookie("soltoken", $token);
}
if (isset($coursename) && ($coursename!="") ){
	setcookie("solcoursename", $coursename);
}


// NOM DES FICHIERS EN SORTIE
$fichier_kml_courant='Sol'; // celui qui est lu par Google Earth; il serait utile de pouvoir modifier ce prefixe depuis le programme
$fichier_kml_cache=$fichier_kml_courant.'_cache'; // celui qui est regénére à chaque appel du programme et archivé

// Fichiers en entrée
// serveur de la course pour la liste des bateaux et leur position
$nomfichier=$prefix.$coursenumber.$extension.'?token='.$token;
$urlsol = "http://node1.sailonline.org/webclient/";

// Données décomprimée
$inflate= '';

entete();

echo '
<div id="menudroite">
';
menu();
echo '</div>
';
echo '<div id="console"><h4>Traitements</h4>
';
if (($action=='go') || ($action=='Valider')){

	if ($action=='go'){
		if (!empty($filename) && file_exists($filename)){
     		echo "Fichier chargé : $filename<br />\n";
			$fp = fopen($filename, "r")  ;
        	if ($contents = fread($fp, filesize($filename))){
				// DEBUG
				// Afficher les premiers octets pour verifier si c'est le protocole deflate ou gzip
				// $lisible= bin2hex($contents);
				// echo '<br /><pre>'."\n";
				// echo substr($lisible,0, 20).'...'."\n";
    	        // echo '</pre>'."\n";

				$inflate= gzBody($contents);
            	fclose($fp);
			}
		}
		else{
    		echo "<br /><br />ERREUR : Fichier absent du disque.\n";
		}
	}
	else if ($action=='Valider'){
		$solserverurl = $urlsol.$nomfichier;
		if (DEBUG){
			echo "<br /> SolServer URL : $solserverurl\n";
		}
		$fp = fopen($solserverurl, "rb");
		if (FALSE === $fp) {
    		echo ("Failed to open stream to URL");
		}
		else{
			if (DEBUG){
				echo "<br /> ACCES autorisé à $solserverurl\n";
			}
			try {
    			if (($contents = file_get_contents($solserverurl)) === false) {
        			// Handle the error
					echo "<br /><br />ERREUR : FILE GET CONTENTS.\n";
    			}
			} catch (Exception $e) {
    			// Handle exception
				print_r($e);
				die("file_get_contents non supported...");
			}

			if (!empty($contents)){
				// DEBUG
				// Afficher les premiers octets pour verifier si c'est le protocole deflate ou gzip
				$lisible= bin2hex($contents);
				if (DEBUG){
					echo '<br /><pre>'."\n";
					echo substr($lisible,0, 20).'...'."\n";
			        echo '</pre>'."\n";
				}
				$inflate= gzBody($contents);
			}
            else{
				echo "<br /><br />ERREUR : FILE GET CONTENTS a retourné un fichier vide.\n";
			}
		}
	}

	// Traiter
	if (empty($inflate)){
  		echo "<br /><br />ERREUR : INFLATE : Le fichier est vide.\n";
	}
	else{
        if (DEBUG){
			echo '<br /><pre>'."\n";
			echo htmlentities($inflate);
        	echo '</pre>'."\n";
		}
		// On va utilier SimpleXML
		$timestamp=time();
		$date=date("Y/m/d H:i:s",$timestamp);

        $race_xml = new SimpleXMLElement($inflate);
		if ($race_xml){
        	if (DEBUG){
				// afficheBoats($race_xml);
			}
			$n=0;
			foreach ($race_xml->boats->boat as $aboat_xml){
				if ((float)$aboat_xml->log==0.0){
						$navstatus='At anchor';
				}
				else{
					if ( (float)$aboat_xml->dtg>0.0){
						$navstatus='Under way sailing';
					}
					else{
	                    $navstatus='Arrived';
					}
				}
                // $cogradian = pi() * ($cogdegre) / 180.0;
                $cogdegre = $aboat_xml->cog * 180.0 / pi();
				// Fabriquer le voilier
                $un_voilier= new Voilier();
				$un_voilier->SetPosition(
                            '',     // mmsi
							$aboat_xml->name,
                            0,                         // SYC (SailOnLine Yacht Club)
                            $aboat_xml->id,
							$date,
							$aboat_xml->lat,
							$aboat_xml->lon,
							$cogdegre,
							0,                        // SOG
                            $navstatus,
							$voile,	// Foc=1, Spi=2,
							0,                          // TWS
							0,                          // TWA
							$aboat_xml->color_R.';'.$aboat_xml->color_G.';'.$aboat_xml->color_B,   // RRR;VVV;BBB
							$aboat_xml->color_G.';'.$aboat_xml->color_B.';'.$aboat_xml->color_R,
       						$aboat_xml->color_B.';'.$aboat_xml->color_R.';'.$aboat_xml->color_G,
							$aboat_xml->color_R.';'.$aboat_xml->color_B.';'.$aboat_xml->color_G,
							$aboat_xml->color_G.';'.$aboat_xml->color_R.';'.$aboat_xml->color_B,
                            $aboat_xml->ranking,
							$aboat_xml->dtg, // distance à courir
    						$aboat_xml->dbl,   // distance au premier
							$aboat_xml->log, // distance parcourue
                            $aboat_xml->current_leg
							);

                $t_voilier[] = $un_voilier;
				echo $aboat_xml->name.', ';
                flush();
				$n++;
			}
		}
	}
}


if ($n){
	echo '<br /><br /><span class="surligne"><b>'.$n.'</b> bateaux chargés...</span>'."\n";
}

echo '</div>
';

//  Génération des données pour G.E.
echo '<div id="display1">
<h4>Fichiers exportés</h4>
';
if (!empty($t_voilier)){
	echo '<h4>Création d\'une nouvelle carte</h4>'."\n";
	echo 'Patientez. L\'importation des données peut prendre plusieurs minutes...'."\n";
	flush();

 	// Structure d'accueil pour les données
	creer_dossier_kml();
	if ($mode=='3D'){ // 3D systématiquement
		if (isset($t_voilier) && is_array($t_voilier) && (count($t_voilier)>0) ){
						echo "<p>Exportation des données en cours...";
						flush();
						// donnees à placer sur un serveur distant : adressage absolue
      					$s=GenereEnteteKML_3D($t_voilier[0]->longitude, $t_voilier[0]->latitude, $t_voilier[0]->cog);
						$s.=GenereMarquesParcoursEtDebutPositionsBateauxKML_3D($okmarques);
						$i=0;
						while ($i<count($t_voilier)){
                    		// $t_voilier[$i]->latitude *= $correction_geodesique;  // tenir compte de la correction de latitude
							$s.=GenereBateauKML_3D($dossier_3d, $url_serveur, $t_voilier[$i], $scale, $scale*150);
							$i++;
						}
						$s.=GenereEnQueueKML_3D();
						EnregistreKML_3D($dossier_3d, $s, false, false);
						GenereKML_3D($dossier_3d, $url_serveur); // Fichier kml a appeler depuis GoogleEarth

						// donnees d'archives : adressage relatif
						$s=GenereEnteteKML_3D($t_voilier[0]->longitude, $t_voilier[0]->latitude, $t_voilier[0]->cog);
						$s.=GenereMarquesParcoursEtDebutPositionsBateauxKML_3D($okmarques);
						$i=0;
						while ($i<count($t_voilier)){
							$s.=GenereBateauKML_3D($dossier_3d_cache, "", $t_voilier[$i], $scale, $scale*150);
							$i++;
						}
						$s.=GenereEnQueueKML_3D();
						EnregistreKML_3D($dossier_3d_cache, $s, true, false);
                        // DEBUG
						/*
						echo "<pre>\n";
						echo htmlspecialchars($s);
						echo "</pre>\n";
						flush();
						*/
			echo "<br />Exportation achevée...</p>";

			unset($t_voilier);
		}
	}
}
echo '</div>
';
// Archives

echo '<div id="display2">
';
echo '<h4>Carte Google Earth disponibles</h4>
';
	/*
	if (file_exists($dir_serveur.'/'.$fichier_kml_courant.$extension_kml)){
		echo '<p align="center"><span class="surligne"/>Vous pouvez télécharger et afficher dans  Google Earth &reg; le fichier <a href="'.$fichier_kml_courant.$extension_kml.'"/><b>'.$fichier_kml_courant.$extension_kml.'</b></a></span>'."\n";
	}

	echo '<p align="center"><span class="surligne"/>Vous pouvez lire dans Google Earth &reg; les fichiers KML / KMZ</span>
';
*/
	afficheArchivesKML();

	$nom_kml=ExisteKML($mode); // Gestion du cache temporel
echo '</div>
';


enqueue();


//---------------------------------------------
function gzBody($gzData){
// decompression à la volée de données comprimées par un serveur
// dans l'entete reçue il y a Accept-Encoding gzip, deflate
	if (!empty($gzData)){
    	if (substr($gzData,0,3)=="\x1f\x8b\x08"){    // Deflate file
        	$i=10;
	        $flg=ord(substr($gzData,3,1));
    	    if($flg>0){
        	    if($flg&4){
            	    list($xlen)=unpack('v',substr($gzData,$i,2));
                	$i=$i+2+$xlen;
	            }
    	        if($flg&8) $i=strpos($gzData,"\0",$i)+1;
        	    if($flg&16) $i=strpos($gzData,"\0",$i)+1;
            	if($flg&2) $i=$i+2;
	        }
    	    return gzinflate(substr($gzData,$i,-8));
    	}
		else{
			// Try Uncompress
        	return gzuncompress($gzData);
	    }
	}
	return false;
}

// ------------------
function selectFichier(){
global $appli;
global $nobj;
global $path;
global $max_ligne;
global $ligne;

global $prefix;
global $extension;

	if (!empty($coursenumber)){
        $pref = $prefix.$coursenumber.'_';
	}
	else{
        $pref = $prefix;
	}
	$tf=array();
	$sep = '/';


	$h1=opendir($path);
    $nobj = 0;
    $n = 0;
	$s='';

    while ($f = readdir($h1) )
    {
		if (($f != ".") && ($f != "..")) {
			// Les fichiers commençant par '_' ne sont pas affichés
			// Ni le fichier par defaut ni le fichier de cache ne sont affichés
			// Les fichiers ne commençant pas par le nom par defaut ne sont pas affichés
			// les fichier n'ayant pas la bonne extension ne sont pas affichés
	        if (!is_dir($path.$sep.$f)){
				// TEXT
    	       	$g= eregi_replace($extension,"",$f) ;
				// DEBUG
				// echo "<br>g:$g  g+:$g$extension_kml  f:$f\n ";
        	  	if (
/*
					(strtoupper($g) != strtoupper($fichier_kml_courant)) // le fichier par defaut n'est pas affiché
					&&
					(strtoupper($g) != strtoupper($fichier_kml_cache)) // le fichier de cache n'est pas affiché
					&&
					(substr($g,0,1) == substr($fichier_kml_courant,0,1)) // Les fichiers ne commençant pas par le nom par defaut ne sont pas affichés
					&&
*/
					(substr($g,0,1) != "_") // Les fichiers commençant par '_' ne sont pas affichés
					&&
					(substr($g,0,strlen($pref)) == $pref)
					&&
					(strtoupper($g.$extension) == strtoupper($f)) // les fichier n'ayant pas la bonne extension ne sont pas affichés
				) {
            	   	$nobj ++;
               		$n ++;
	               	$tf[$f] = $f ;
				}

			} // fin traitement d'un fichier
		} // fin du test sur entrees speciales . et ..
	}  // fin du while sur les entrees du repertoire traite

	closedir($h1);

	if ($n != 0) {
	    asort($tf);
		$s.= '<h5>Sélectionnez un fichier local</h5>'."\n";
		$s.= '<ul>'."\n";
       	while (list($key) = each($tf)) {
	       	$s.= '<li><a  class="small" href="'.$appli.'?filename='.urlencode($path.$sep.$key).'">'.$tf[$key].'</a></li>'."\n";
   		}
   		$s.= '</ul>'."\n";
	}
	else{
    	$s.= 'Aucun fichier pour cette course'."\n";
	}
	$s.= '<br /><br/>'."\n";
	return $s;
}


//---------
function entete(){
	global $appli;
	global $nomfichier;
	global $coursenumber;
	global $coursename;
	global $token;
	global $dir_serveur;
	global $fichier_kml_courant;
	global $extension_kml;
	global $okfichier_charge;
    global $voile;

	echo '<!DOCTYPE html>
<html  dir="ltr" lang="fr" xml:lang="fr">
<head>
	<title>Sailonline :: Google Earth</title>
	<meta name="ROBOTS" content="none,noarchive">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta name="Author" content="JF">
	<meta name="description" content="Courses SailOnLine."/>
    <link rel="author" title="Auteur" href="mailto:jean.fruitet@free.fr">
	<link href="style1.css" rel="stylesheet" type="text/css">
</head>
<body>

<div id="bandeau">
<h1 align="center">Cartes SailOnLine pour Google Earth (format KML / KMZ)</h1>
<p align="center"><a href="./sol2kml-v2_en.php"/>English version</a>
-
(<a target="_blank" href="https://creativecommons.org/licenses/by-sa/3.0/fr/">cc-by sa</a>) <a href="mailto:jean.fruitet@free.fr">JF</a></p>
<div id="menugauche">

<h4>Connexion au serveur de SailOnLine</h4>
<p><span class="small"><b>Avertissement</b>
<br />
Vous devez disposer d\'un compte d\'accès à <a target="_blank" href="http://www.sailonLline.org"</a>Sailonline</a>)
<br />et compléter le formulaire ci-après.
<br /><a target="_blank" href="https://soltools.wordpress.com/2012/05/07/data-from-sailonline-server/">Aide pour se connecter</a>.</span>
';

	echo '
<form action="'.$appli.'" method="post">
* <b><i><label for="text1">N° de course</label></i></b><br /><input type="text" class="textInput" id="text1"  name="coursenumber" size="4" value="'.$coursenumber.'" />
<br />
* <b><i><label for="text2">Token</label></i></b><br /><input type="text" class="textInput" id="text2"  name="token" size="35" value="'.$token.'" />
<br />
<b><i><label for="text3">Nom de course</label></i></b><br /><input type="text" class="textInput2" id="text3"  name="coursename" size="35" value="'.$coursename.'" />
<br /><br />
<input type="reset" value="Corriger" />
<input id="submitBtn" type="submit" name="action" value="Valider" />
 <i><label for="text4">Cliquer pour charger les données.</label></i>
</form>
';

	echo '
<br /><br />
<form action="'.$appli.'" method="post">
<b>Voile à arborer sur les bateaux</b><br />(En fonction du vent sur zone et du cap général de la flotte)
<br />
<select name="voile" name="voile" id="voile" size="2">
';
	if ($voile==1){
		echo '<option value="1" SELECTED>Foc</option>
<option value="2">Spi</option>
';
	}
	else{
		echo '<option value="1">Foc</option>
<option value="2" SELECTED>Spi</option>
';
	}
	echo '
</select>
<br /><br />
<input type="reset" value="Corriger" />
<input type="submit" name="action" value="Choisir" />
</form>
';
	echo '<h4>Télécharger un fichier local</h4>
';
	echo selectFichier($coursenumber);

 	if ($okfichier_charge){
		echo '<p>Les données sont disponibles pour créer une carte'."</p>\n";
	}

	echo '</div>
';

}

//---------
function enqueue(){
echo '
<div id="piedpage">(<a target="_blank" href="https://creativecommons.org/licenses/by-sa/3.0/fr/">cc - by sa</a>) JF 2016-2017</div>
</body>
</html>';
}


// ----------------------------
function get_url_pere($path) {
// Retourne l'URL du répertoire contenant le script
// global $PHP_SELF;
// DEBUG
// echo "<br>PHP_SELF : $PHP_SELF\n";
//	$path = $PHP_SELF;
	$nomf = substr( strrchr($path, "/" ), 1);
	if ($nomf){
		$pos = strlen($path) - strlen($nomf) - 1;
		$pere = substr($path,0,$pos);
	}
	else
		$pere = $path;
	return $pere;
}


//------------------------------
function afficheBoats($race_xml){
	if (!empty($race_xml)){
        //echo '<br />SimpleXML Element<pre>'."\n";
 		//print_r( $race_xml);
        //echo '</pre>'."\n";
		// DEBUG
		echo '<br /><b>Id de la course</b>: <i>'.$race_xml->id.'</i>'."\n";
		echo '<br /><b>Nom de la course</b>: <i>'.$race_xml->message.'</i>'."\n";
        echo '<br /><b>Alerte </b>: <i>'.$race_xml->alert.'</i>'."\n";
        echo '<br /><b>Boats</b>:<br />'."\n";
		/*
			echo '<pre>'."\n";
      		print_r($race_xml->boats);
            echo '</pre><br />'."\n";
		*/
        echo '<ol>'."\n";
		foreach ($race_xml->boats->boat as $aboat){
			afficheABoat($aboat);
		}
        echo '</ol>'."\n";
	}
}


//------------------------------
function afficheABoat($aBoat_xml){
	if (!empty($aBoat_xml)){
        //echo '<br />SimpleXML Element<pre>'."\n";
 		//print_r( $aBoat_xml);
        //echo '</pre>'."\n";
		// DEBUG
        echo '<li><b>'.$aBoat_xml->name.'</b><br /><ul>'."\n";
		echo '<li>Sol id: <i>'.$aBoat_xml->id.'</i>'."\n";
		echo '<li>Couleur coque: '.$aBoat_xml->color_R.','.$aBoat_xml->color_G.','.$aBoat_xml->color_B.''."\n";
        echo '<li>Modèle: '.$aBoat_xml->type.''."\n";
        echo '<li>Distance à courir: '.$aBoat_xml->dtg.''."\n";
        echo '<li>Distance au premier: '.$aBoat_xml->dbl.''."\n";
        echo '<li>Longitude: <i>'.$aBoat_xml->lon.'</i>'."\n";
 		echo '<li>Latitude: <i>'.$aBoat_xml->lat.'</i>'."\n";
 		echo '<li>COG: '.$aBoat_xml->cog.''."\n";
 		echo '<li>Rang: '.$aBoat_xml->ranking.''."\n";
 		echo '<li>Manche: '.$aBoat_xml->current_leg.''."\n";
        echo '<li>Distance parcourue: '.$aBoat_xml->log.''."\n";
        echo '</ul><br /></li>'."\n";
	}
}


//-----------------------------------
function SetCouleurVoilierHexa2Dec($bcouleur){
	// $boat->couleur  	= "coque,voile,foc,spi" coque:ffffff,voile:ffff33,foc:ffffff,spi:ee33ef
	// $voilier->une_couleur_par_element au formar RRR;VVV;BBB entre 0 et 255
	$tcol_v = new stdClass();
	$tcol_v->couleur_coque=255; // coque    RRR;VVV;BBB
	$tcol_v->couleur_vav=255; // GV
	$tcol_v->couleur_gv=255; // VoileAvant
	$tcol_v->couleur_spi=255; // Spi
	$tcol_v->couleur_spi2=255; // Spi 2

    if ($bcouleur){
		list($ccoque, $cvoile, $cfoc, $cspi) = explode(',', $bcouleur);
           $tcol_v->couleur_coque = hexa2_3dec($ccoque);
           $tcol_v->couleur_vav = hexa2_3dec($cfoc);
           $tcol_v->couleur_gv = hexa2_3dec($cvoile);
           $tcol_v->couleur_spi = hexa2_3dec($cspi);
           $tcol_v->couleur_spi2 = hexa2_3dec($cspi);
	}

	return ($tcol_v);
}

//-------------------------
function hexa2_3dec($hexa){
	// rrvvbb -> hexdec(rr);hexdec(vv);hexdec(bb)
    if (list($rr, $vv, $bb) = explode(';', chunk_split ($hexa,2,';'))){
		return (hexdec($rr).';'.hexdec($vv).';'.hexdec($bb));
	}
	return false;
}


// -----------------------
function ExisteKML($ok3d=true){
	// verifie si une generation a ete faite durant l'heure courante
	if ($ok3d){
		return ExisteKML_3D();
	}
	else{
        return ExisteKML_2D();
	}
}


// ---------------------------
function menu(){
global $time_cache;
global $str_time_cache;
global $scale;
global $mode;
global $url_serveur;
global $url_serveur_local;
global $utiliser_cache; // par defaut il y a un cache d'une heure sur les donnes des voiliers
global $appli;

	echo '
<h4>Paramètres d\'exportation des fichiers KML/KMZ</h4>
<h5 align="center"><b>Serveur de cartes KML/KMZ</b></h5>
<form action="'.$appli.'" method="post" name="saisie_serveur" id="saisie_serveur">
<b>URL du serveur</b> où seront disponibles les fichiers KML / KMZ
<br /><i>'.$url_serveur .'</i>
<br /><br />
<b>Sélectionner une autre URL</b>
<br />
<select name="url_serveur" id="url_serveur" size="3">
';
		if ($url_serveur_local==$url_serveur){
			echo '<option value="'.$url_serveur_local.'" SELECTED>'.$url_serveur_local.'</option>';
		}
		else{
			echo '<option value="'.$url_serveur_local.'"/>'.$url_serveur_local.'</option>';
		}

		if ('http://voilevirtuelle.free.fr/KML/3D'==$url_serveur){
			echo '<option value="http://voilevirtuelle.free.fr/KML/3D" SELECTED>http://voilevirtuelle.free.fr/KML/3D</option>';
		}
		else{
			echo '<option value="http://voilevirtuelle.free.fr/KML/3D"/>http://voilevirtuelle.free.fr/KML/3D</option>';
		}

		if ('http://jean.fruitet.free.fr/vgv/vgv2016'==$url_serveur){
			echo '<option value="http://jean.fruitet.free.fr/vgv/vgv2016" SELECTED>http://jean.fruitet.free.fr/vgv/vgv2016</option>';
		}
		else{
			echo '<option value="http://jean.fruitet.free.fr/vgv/vgv2016"/>http://jean.fruitet.free.fr/vgv/vgv2016</option>';
		}

	echo '
</select>

<br /><br />
<b>Saisir une nouvelle URL</b> :
<br />
<span class="small">N.B. : Si vous utilisez la version en ligne ne modifiez pas l\'adresse du serveur</span>
<br />
<input type="text" name="new_serveur" id="new_serveur" value="" size="40" maxlength="255"/>
<br />

<input type="reset" value="Corriger"/>
<input type="submit" name="action" id="action" value="Serveur"/>
<input type="hidden" name="mode" id="mode" value="'.$mode.'"/>
<input type="hidden" name="scale" id="scale" value="'.$scale.'"/>
</form>

<h5 align="center"><b>Mode d\'affichage des bateaux</b></h5>
<form action="'.$appli.'" method="post" name="saisie_mode" id="saisie_mode"/>
<b>Affichage 3D</b>
<br />(<span class="small">En volumes, au cap, avec la voile du temps</span>)
<br /> Echelle des voiliers :
<input type="text" name="scale" size="1" maxsize="3" value="'.$scale.'"/>
(<span class="small">[<i>0.1</i>, <i>20.0</i>].</span>)
<br /><br />
<input type="reset" value="Corriger"/>
<input type="submit" value="Valider"/>
<input type="hidden" name="url_serveur" id="url_serveur" value="'.$url_serveur.'"/>
</form>
';
}



// ------------------
function afficheImages($prefixe_image='so', $extension_image='jpg'){
$nobj=0;
$ndir=0;
$njpg=0;
$tjpg=array();
// DEBUG
// echo "<br>Fichier KML courant : $fichier_kml_courant\n";
	$tjpg=array();
	$sep = '/';
	$path="./images";

	$h1=opendir($path);
    while ($f = readdir($h1) )
    {
		if (($f != ".") && ($f != "..")) {
			// Les fichiers commençant par '_' ne sont pas affichés
			// Ni le fichier par defaut ni le fichier de cache ne sont affichés
			// Les fichiers ne commençant pas par le nom par defaut ne sont pas affichés
			// les fichier n'ayant pas la bonne extension ne sont pas affichés
	        if (!is_dir($path.$sep.$f)){
				// KML
    	       	$g= eregi_replace($extension_image,"",$f) ;
				// DEBUG
				// echo "<br>g:$g  g+:$g$extension_image  f:$f\n ";
        	  	if (
					(substr($g,0,3) == substr($prefixe_image,0,3)) // Les fichiers ne commençant pas par le nom par defaut ne sont pas affichés
					&&
					(substr($g,0,1) != "_") // Les fichiers commençant par '_' ne sont pas affichés
					&&
					(strtoupper($g.$extension_image) == strtoupper($f)) // les fichier n'ayant pas la bonne extension ne sont pas affichés
				) {
            	   	$nobj ++;
               		$njpg ++;
	               	$tjpg[$f] = $f ;
				}
			} // fin traitement d'un fichier
		} // fin du test sur entrees speciales . et ..
	}  // fin du while sur les entrees du repertoire traite

	closedir($h1);

    $colonne=0;
    $max_colonne=6;

	if ($njpg > 0) {
		echo '<h5 align="center">Image' ;
        if ($njpg > 1 ){
			echo 's';
		}
		echo ' Captures d\'écran Google Earth</h5>'."\n";
		echo '<table align="center" width="90%" cellspacing="1" cellpadding="4" border="0" bgcolor="#333300">'."\n";
		echo '<tr valign="top" bgcolor="#ffff33">'."\n";
	    asort($tjpg);
		while (list($key) = each($tjpg)) {
	       	echo '<td><a href="'.$path.$sep.$key.'">'.$tjpg[$key].'</a></td>'."\n";
            $colonne++;
			if ($colonne>=$max_colonne){
    			echo '</tr><tr valign="top" bgcolor="#ffffff">'."\n";
    			$colonne=0;
			}
    	}
		while($colonne<$max_colonne){
    		echo '<td>&nbsp;</td>'."\n";
			$colonne++;
		}

    	echo '</tr></table>'."\n";
	}
}

// ------------------
function afficheArchivesKML(){
global $nobj;
global $ndir;
global $nkml;
global $tkml;
global $nkmz;
global $tkmz;
global $max_ligne;
global $ligne;
//global $fichier_kml_courant;
//global $fichier_kml_cache;
global $extension_kml;
//global $fichier_kmz_courant;
//global $fichier_kmz_cache;
global $extension_kmz;

// DEBUG
// echo "<br>Fichier KML courant : $fichier_kml_courant\n";
	$tikml=array();
	$tikmz=array();
	$sep = '/';
	$path=".";

	$h1=opendir($path);
    $nobj = 0;
    $nkml = 0;
	$nkmz = 0;
	$ndir = 0;

    while ($f = readdir($h1) )
    {
		if (($f != ".") && ($f != "..")) {
			// Les fichiers commençant par '_' ne sont pas affichés
			// Ni le fichier par defaut ni le fichier de cache ne sont affichés
			// Les fichiers ne commençant pas par le nom par defaut ne sont pas affichés
			// les fichier n'ayant pas la bonne extension ne sont pas affichés
	        if (!is_dir($path.$sep.$f)){
				// KML
    	       	$g= eregi_replace($extension_kml,"",$f) ;
				// DEBUG
				// echo "<br>g:$g  g+:$g$extension_kml  f:$f\n ";
        	  	if (
/*
					(strtoupper($g) != strtoupper($fichier_kml_courant)) // le fichier par defaut n'est pas affiché
					&&
					(strtoupper($g) != strtoupper($fichier_kml_cache)) // le fichier de cache n'est pas affiché
					&&
					(substr($g,0,1) == substr($fichier_kml_courant,0,1)) // Les fichiers ne commençant pas par le nom par defaut ne sont pas affichés
					&&
*/
					(substr($g,0,1) != "_") // Les fichiers commençant par '_' ne sont pas affichés
					&&
					(strtoupper($g.$extension_kml) == strtoupper($f)) // les fichier n'ayant pas la bonne extension ne sont pas affichés
				) {
            	   	$nobj ++;
               		$nkml ++;
	               	$tikml[$f] = $f ;
				}
				// KML
    	       	$g= eregi_replace($extension_kmz,"",$f) ;
				// DEBUG
				// echo "<br>g:$g  g+:$g$extension_kml  f:$f\n ";
        	  	if (
/*
					(strtoupper($g) != strtoupper($fichier_kmz_courant)) // le fichier par defaut n'est pas affiché
					&&
					(strtoupper($g) != strtoupper($fichier_kmz_cache)) // le fichier de cache n'est pas affiché
					&&
					(substr($g,0,1) == substr($fichier_kml_courant,0,1)) // Les fichiers ne commençant pas par le nom par defaut ne sont pas affichés
					&&
*/
					(substr($g,0,1) != "_") // Les fichiers commençant par '_' ne sont pas affichés
					&&
					(strtoupper($g.$extension_kmz) == strtoupper($f)) // les fichier n'ayant pas la bonne extension ne sont pas affichés
				) {
            	   	$nobj ++;
               		$nkmz ++;
	               	$tikmz[$f] = $f ;
				}

			} // fin traitement d'un fichier
		} // fin du test sur entrees speciales . et ..
	}  // fin du while sur les entrees du repertoire traite

	closedir($h1);

	if (($nkml != 0) || ($nkmz != 0)) {
		/*
		echo '<h5>Archive' ;
        if (($nkml > 1 ) || ($nkmz > 1 )){
			echo 's';
		}
		echo ' Google Earth  KML / KMZ</h5>'."\n";
		*/
		echo '<p><span class="small">Ouvrez ces fichiers dans G.E.
		<br />(<i>En nettoyant au besoin dans Google Earth
la liste des <b>Lieux temporaires</b>.</i></span></p>'."\n";
		if (($nkml > 0) || ($nkmz > 0)){
			if ( $nkml > 0){
            	echo '<b>Fichiers KML</b><br />'."\n";
		        asort($tikml);
				while (list($key) = each($tikml)) {
		        	echo '<a  class="small" href="'.$path.$sep.$key.'">'.$tikml[$key].'</a>  &nbsp; &nbsp; &nbsp; '."\n";
    			}
			}
			if ( $nkmz > 0){
				echo '<br /><br /><b>Fichiers KMZ</b><br />'."\n";
		        asort($tikmz);
				while (list($key) = each($tikmz)) {
		        	echo '<a  class="small" href="'.$path.$sep.$key.'">'.$tikmz[$key].'</a>  &nbsp; &nbsp; &nbsp; '."\n";
    			}
			}
			echo '<br /><br/>'."\n";
		}
	}
	else{
        echo '<p> Aucun fichier  KML / KMZ à consulter</p>'."\n";
	}
}

//------------------------
function creer_dossier_kml(){
// Crée un dossier unique pour archiver les donnees KML
global $dir_serveur;
global $dossier_3d;
global $dossier_3d_cache;
global $dossier_textures;
global $dossier_modeles;

	$dir_name=$dir_serveur.'/'.$dossier_3d;
	if (!file_exists($dir_name)){
		mkdir($dir_name);
	}
	$dir_name=$dir_serveur.'/'.$dossier_3d.'/'.$dossier_modeles;
	if (!file_exists($dir_name)){
		mkdir($dir_name);
	}
	$dir_name=$dir_serveur.'/'.$dossier_3d.'/'.$dossier_textures;
	if (!file_exists($dir_name)){
		mkdir($dir_name);
	}

	$dossier_3d_cache=$dossier_3d.'_'.date("YmdH");
	$dir_name=$dir_serveur.'/'.$dossier_3d_cache;
	if (!file_exists($dir_name)){
		mkdir($dir_name);
	}
	$dir_name=$dir_serveur.'/'.$dossier_3d_cache.'/'.$dossier_modeles;
	if (!file_exists($dir_name)){
		mkdir($dir_name);
	}
	$dir_name=$dir_serveur.'/'.$dossier_3d_cache.'/'.$dossier_textures;
	if (!file_exists($dir_name)){
		mkdir($dir_name);
	}
}

class UploadException extends Exception
{
    public function __construct($code) {
        $message = $this->codeToMessage($code);
        parent::__construct($message, $code);
    }

    private function codeToMessage($code)
    {
        switch ($code) {
            case UPLOAD_ERR_INI_SIZE:
                $message = "The uploaded file exceeds the upload_max_filesize directive in php.ini";
                break;
            case UPLOAD_ERR_FORM_SIZE:
                $message = "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form";
                break;
            case UPLOAD_ERR_PARTIAL:
                $message = "The uploaded file was only partially uploaded";
                break;
            case UPLOAD_ERR_NO_FILE:
                $message = "No file was uploaded";
                break;
            case UPLOAD_ERR_NO_TMP_DIR:
                $message = "Missing a temporary folder";
                break;
            case UPLOAD_ERR_CANT_WRITE:
                $message = "Failed to write file to disk";
                break;
            case UPLOAD_ERR_EXTENSION:
                $message = "File upload stopped by extension";
                break;

            default:
                $message = "Unknown upload error";
                break;
        }
        return $message;
    }
}



?>